From ec9e0ae311d9bbe04610ad4abe294d23b20db268 Mon Sep 17 00:00:00 2001
From: Jacob Champion <jchampion@timescale.com>
Date: Thu, 16 Feb 2023 13:40:47 -0800
Subject: [PATCH] WIP: support official SASL channel bindings

...instead of the "ldap" types.
---
 libraries/libldap/cyrus.c | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

diff --git a/libraries/libldap/cyrus.c b/libraries/libldap/cyrus.c
index e713e58dc..a0a64b745 100644
--- a/libraries/libldap/cyrus.c
+++ b/libraries/libldap/cyrus.c
@@ -385,14 +385,10 @@ int ldap_pvt_sasl_cbinding_parse( const char *arg )
 void *ldap_pvt_sasl_cbinding( void *ssl, int type, int is_server )
 {
 #if defined(SASL_CHANNEL_BINDING) && defined(HAVE_TLS)
-	char unique_prefix[] = "tls-unique:";
-	char endpoint_prefix[] = "tls-server-end-point:";
 	char cbinding[ 64 ];
 	struct berval cbv = { 64, cbinding };
 	unsigned char *cb_data; /* used since cb->data is const* */
 	sasl_channel_binding_t *cb;
-	char *prefix;
-	int plen;
 
 	switch (type) {
 	case LDAP_OPT_X_SASL_CBINDING_NONE:
@@ -400,25 +396,27 @@ void *ldap_pvt_sasl_cbinding( void *ssl, int type, int is_server )
 	case LDAP_OPT_X_SASL_CBINDING_TLS_UNIQUE:
 		if ( !ldap_pvt_tls_get_unique( ssl, &cbv, is_server ))
 			return NULL;
-		prefix = unique_prefix;
-		plen = sizeof(unique_prefix) -1;
 		break;
 	case LDAP_OPT_X_SASL_CBINDING_TLS_ENDPOINT:
 		if ( !ldap_pvt_tls_get_endpoint( ssl, &cbv, is_server ))
 			return NULL;
-		prefix = endpoint_prefix;
-		plen = sizeof(endpoint_prefix) -1;
 		break;
 	default:
 		return NULL;
 	}
 
-	cb = ldap_memalloc( sizeof(*cb) + plen + cbv.bv_len );
-	cb->len = plen + cbv.bv_len;
+	cb = ldap_memalloc( sizeof(*cb) + cbv.bv_len );
+	cb->len = cbv.bv_len;
 	cb->data = cb_data = (unsigned char *)(cb+1);
-	memcpy( cb_data, prefix, plen );
-	memcpy( cb_data + plen, cbv.bv_val, cbv.bv_len );
-	cb->name = "ldap";
+	memcpy( cb_data , cbv.bv_val, cbv.bv_len );
+	switch (type) {
+	case LDAP_OPT_X_SASL_CBINDING_TLS_UNIQUE:
+		cb->name = "tls-unique";
+		break;
+	case LDAP_OPT_X_SASL_CBINDING_TLS_ENDPOINT:
+		cb->name = "tls-server-end-point";
+		break;
+	}
 	cb->critical = 0;
 
 	return cb;
-- 
2.25.1

